const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const applications = sequelize.define(
    'applications',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      submitted_at: {
        type: DataTypes.DATE,
      },

      status: {
        type: DataTypes.ENUM,

        values: ['Pending', 'Reviewed', 'Rejected'],
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  applications.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.applications.hasMany(db.interviews, {
      as: 'interviews_application',
      foreignKey: {
        name: 'applicationId',
      },
      constraints: false,
    });

    db.applications.hasMany(db.offers, {
      as: 'offers_application',
      foreignKey: {
        name: 'applicationId',
      },
      constraints: false,
    });

    //end loop

    db.applications.belongsTo(db.candidates, {
      as: 'candidate',
      foreignKey: {
        name: 'candidateId',
      },
      constraints: false,
    });

    db.applications.belongsTo(db.job_requisitions, {
      as: 'requisition',
      foreignKey: {
        name: 'requisitionId',
      },
      constraints: false,
    });

    db.applications.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.applications.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.applications.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return applications;
};
